{ This procedure will get all words from a string.   }
{ You specify what character to use as seperator in  }
{ the code below. A search string can look like this:}
{ word1;word2;word3;word4;word5;word6;word7;word8    }
{ Eight words will be parsed and added to a ListBox. }
{ If you want spaces after each word                 }
{ (i.e. word1; word2; word3 etc), you'll have to     }
{ modify the code. See comment below. Good luck!     }

{ Daniel Jensen (nocomply@as-if.com)                 }

unit Parser;

interface

uses
  SysUtils,Classes,Controls,Forms,StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    ListBox1: TListBox;
    Label1: TLabel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{Begin checking for words}
{******************************************************************************}
procedure TForm1.Button1Click(Sender: TObject);
var
    {The string containing the text to search in}
    SearchText:string;
    {Index values to use in the procedure}
    i,start,stop,found:integer;
begin

    {Add the text in Edit1 to SearchText}
    SearchText:=Edit1.Text;
    {Set start to 1,}
    start:=1;
    {and found to 0}
    found:=0;
    {Clear the ListBox}
    ListBox1.Clear;

    {We'll search through the entire string}
    for i := 1 to Length(SearchText) do begin
      {If a character is a semi-colon then}
      if Copy(SearchText,i,1)=';'then begin
        {Set stop to the position - 1 (we don't want the semi-colon)}
        stop:=i-1;
        {Add word to the ListBox}
        ListBox1.Items.Add(Copy(SearchText,start,stop-start+1));
        {Set new start (next word)}
        {If you use spaces after the semi-colons you'll have to change}
        {the value to i+spaces+1, where spaces is the number of white spaces}
        {you have after each semi-colon}
        start:=i+2;
        {Increase the found variable if it's not the final character}
        if i<>Length(SearchText) then inc(found);
      end;
    end;

    {We're not sure there's a ; after the last word}
    {If the last character is NOT a semi-colon and if there's text in the EditBox}
    if (Copy(SearchText,Length(SearchText)-1,1)<>';') and (Edit1.Text<>'') then begin
      {Add word to ListBox}
      ListBox1.Items.Add(Copy(SearchText,start,Length(SearchText)-start+1));
      {Increase found}
      inc(found)
    end;

    {Perhaps there's only one word, and no semi-colons}
    if (found=0) and (Edit1.Text<>'') then begin
      if Copy(SearchText,Length(SearchText)-1,1)<>';' then begin
        {Then we'll add it to the ListBox, and set found to 1}
        ListBox1.Items.Add(Copy(SearchText,start,Length(SearchText)-start+1));
        found:=1;
      end;
    end;

    {Show how many words there was}
    Label1.Caption:=IntToStr(found)+' words found';

end;
{******************************************************************************}

end.
